using Library;
using MySystem.PxcModels;
using System;
using System.Linq;

namespace MySystem
{
    public class MachineApplyHelper
    {
        public readonly static MachineApplyHelper Instance = new MachineApplyHelper();
        private MachineApplyHelper()
        { }

        public string Start()
        {
            bool op = true;
            WebCMSEntities db = new WebCMSEntities();
            string result = "";
            int total = 0;
            while (op)
            {
                MachineApply PopData = new MachineApply();
                try
                {
                    //获取apserver待同步的数据，执行入库
                    PopData = RedisDbconn.Instance.RPop<MachineApply>("Pop:MachineApply");
                    if (PopData != null)
                    {
                        MachineApply checkExist = db.MachineApply.FirstOrDefault(m => m.Id == PopData.Id);
                        if (checkExist != null)
                        {
                            checkExist = PopData;
                        }
                        else
                        {
                            db.MachineApply.Add(PopData);
                        }
                        if (total >= 20)
                        {
                            total = 0;
                            db.SaveChanges();
                        }
                        if (string.IsNullOrEmpty(result)) result = "success";
                    }
                    else
                    {
                        db.SaveChanges();
                        op = false;
                    }
                }
                catch (Exception ex)
                {
                    ErrorMsg msg = new ErrorMsg();
                    msg.Obj = PopData;
                    msg.Time = DateTime.Now;
                    msg.ErrorContent = ex.ToString();
                    function.WriteLog(Newtonsoft.Json.JsonConvert.SerializeObject(msg), "Pop:MachineApply:Error");
                    result = "有异常，请查看Pop:MachineApply:Error队列";
                }
            }
            db.Dispose();
            return result;
        }
    }
}